#include "Manifest.h"
#include "resourceids.h"

Boolean Manifest_checkManifest(void)
{
  DmOpenRef manifestDatabase;
  Boolean success = false;
  
  manifestDatabase = DmOpenDatabaseByTypeCreator('Mani', 'Shwg', dmModeReadOnly);
  if (manifestDatabase)
  {
    UInt16 i;
    UInt16 numRecords;
    UInt16 numCards = MemNumCards();


    numRecords = DmNumRecords(manifestDatabase);

    for (i = 0; i < numRecords; i++)
    {
      MemHandle hrec;
      MemPtr prec;
      UInt16 card;
      LocalID id=0;
      UInt16 manifestVersion;
      Boolean mandatory;
      const UInt8 *dbName; 
      const UInt8 *p;
      UInt16 version=0;
      
      success = false;
      hrec = DmQueryRecord(manifestDatabase, i);
      prec = MemHandleLock(hrec);
      dbName = (const UInt8 *)prec;
      p = &dbName[StrLen(dbName)+1];
      manifestVersion = (p[0]<<8)|p[1];
      mandatory = (p[3]&0x1)?true:false;


      for (card = 0; card < numCards; card++)
      {

        id = DmFindDatabase(card, dbName);
        if (id != 0)
        {

          DmDatabaseInfo(card, id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

          if (version == manifestVersion)
          {
            success = true;
          }
          break;
        }
      }

      if (!success)
      {
        success =  ((!mandatory) && (version == 0));
      }

      MemHandleUnlock(hrec);

      if (!success)
      {
        break;
      }
    }
    DmCloseDatabase (manifestDatabase);
  }
 
  return success;
}