#ifndef MAP_H__730E4C83_6D80_78D4_2C1F_465B077E4FFE
#define MAP_H__730E4C83_6D80_78D4_2C1F_465B077E4FFE

#include "DataMgr.h"

#include "viewer.h"
#include "WindowsRect.h"

typedef struct
{
    UInt16 m_unknown0;

    UInt16 m_left;
    UInt16 m_top;
    UInt16 m_right;
    UInt16 m_bottom;
} MapHeader;

typedef struct
{
    UInt8 m_recordType;
    UInt8 m_recordLength;

    UInt16 m_left;
    UInt16 m_top;
    UInt16 m_right;
    UInt16 m_bottom;

    UInt16 m_unknown1;
    const UInt8 *m_boothNumber;
} MapToBoothNumber;


typedef struct
{
    UInt8 m_recordType;
    UInt8 m_recordLength;

    UInt16 m_left;
    UInt16 m_top;
    UInt16 m_right;
    UInt16 m_bottom;

    const UInt8 *m_exhibitorName;
    const UInt8 *m_recordTypeAndExhibitorRecordNum;
} MapToExhibitorName;

typedef struct
{
    DmOpenRef m_database;
    RECT m_mapRect;

    UInt32 m_boothRecordNumbersSize;
    UInt32 m_boothRecordNumbersCount;
    UInt32 *m_boothRecordNumbers;

    UInt32 m_exhibitorRecordNumbersSize;
    UInt32 m_exhibitorRecordNumbersCount;
    UInt32 *m_exhibitorRecordNumbers;
} Map;



extern Map *Map_new(void) MAPVIEWER_SECTION;
extern void Map_delete(Map *map) MAPVIEWER_SECTION;
extern void Map_locateFirstMapToBoothNumber(Map *map) MAPVIEWER_SECTION;
extern void Map_locateNextMapToBoothNumber(Map *map) MAPVIEWER_SECTION;
extern MapToBoothNumber *Map_getCurrentMapToBoothNumber(Map *map) MAPVIEWER_SECTION;



#endif

