#ifndef MAPVIEWERFORM_H__1AF779E8_36EB_3117_637B_265839490DD1
#define MAPVIEWERFORM_H__1AF779E8_36EB_3117_637B_265839490DD1

#include "Map.h"
#include "viewer.h"

typedef struct
{
    Map *m_map;
    float m_scale;

    /*
        In map coordinates.
    */
    Int32 m_xCentre;
    Int32 m_yCentre;

    /*
        In screen coordinates.
    */
    Int32 m_xOffset;
    Int32 m_yOffset;
    UInt32 m_xMouseDown;
    UInt32 m_yMouseDown;

    Boolean m_mouseMovedSinceButtonDown;

    RECT m_highlightRect;
    Boolean m_highlightOn;
    Boolean m_highlightEnabled;
    UInt32 m_highlightPeriod;
    UInt32 m_highlightLastSwitch;

} MapViewer;

extern MapViewer *theMapViewer MAPVIEWER_SECTION;

extern MapViewer *MapViewer_new(void) MAPVIEWER_SECTION;
extern void MapViewer_delete(MapViewer *self) MAPVIEWER_SECTION;

extern void MapViewer_initialise(MapViewer *self, const RECT *windowRect) MAPVIEWER_SECTION;
extern void MapViewer_centre(MapViewer *self, const RECT *windowRect) MAPVIEWER_SECTION;
extern void MapViewer_show(MapViewer *self, RECT *windowRect) MAPVIEWER_SECTION;
extern void MapViewer_setHighlight(MapViewer *self, RECT *highlightRect) MAPVIEWER_SECTION;

extern Boolean MapViewerFormHandleEvent( EventType* event ) MAPVIEWER_SECTION;

#endif

