// -*- c++ -*-

// Copyright (c) 2006 PDA Verticals Corp.
// All rights reserved.
// 
// $Id: palm_platform.h 1859 2006-05-02 21:38:42Z dave $
// $URL: https://projects.svn.pdaverticals.com/trunk/beamstation/src/common/palm_platform.h $

#ifndef PALM_PLATFORM_H__605B64C9_EDF2_4974_83DF_B369DC251B63
#define PALM_PLATFORM_H__605B64C9_EDF2_4974_83DF_B369DC251B63

// Custom launch codes and other declarations for use in the Updater and
// the Reader applications on PalmOS.

// Launch codes that programs can send to the reader

// Tells the reader to verify that it's not running. The reader should
// return 1 if it is not running (implying that updates will be
// safe). Otherwise it should return 0 and also take steps to exit the
// application and call the updater with an
// updaterLaunchCodeQueueUpdatesRequest just before the reader exits.
#define rdrLaunchCodeVerifyUpdatesAreSafe 32768

// Launch codes that programs can send to the updater

// Tells the updater to queue an update request. The updater should not
// take any steps to verify that with the reader that updates are safe.
#define updaterLaunchCodeQueueUpdatesRequest 32768

// Alarm codes that programs can send to the updater
#define alarmRunUpdaterAfterPing        1 
#define alarmRunUpdaterAfterReaderExit  2

#endif
